import java.io.*;
import java.net.*;

public class KnockKnockClient {
	
	
    public final static int DEFAULT_PORT = 4444;		
	
    public static void main(String[] args) throws IOException {

        Socket kkSocket = null;
        PrintWriter out = null;
        BufferedReader in = null;
	
	
	String hostname;
        int port = DEFAULT_PORT;
	
	if (args.length > 0) {
               hostname = args[0];
        }  else  hostname = "xapacura.icmc.usp.br";
         

        if (args.length > 1) {
        try {port = Integer.parseInt(args[1]);}
        catch (NumberFormatException e) {}
        }
	

        try {
            kkSocket = new Socket(hostname, port);
            out = new PrintWriter(kkSocket.getOutputStream(), true);
            in = new BufferedReader(new InputStreamReader(kkSocket.getInputStream()));
        } catch (UnknownHostException e) {
            System.err.println("hostname desconhecido: "+ hostname);
            System.exit(1);
        } catch (IOException e) {
            System.err.println("Erro de conexao na porta: "+port+" no host: "+hostname);
            System.exit(1);
        }

        BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
        String fromServer;
        String fromUser;

        while ((fromServer = in.readLine()) != null) {
            System.out.println("Server: " + fromServer);
            if (fromServer.equals("Bye."))
                break;
		    
            fromUser = stdIn.readLine();
	    if (fromUser != null) {
                System.out.println("Client: " + fromUser);
                out.println(fromUser);
	    }
        }

        out.close();
        in.close();
        stdIn.close();
        kkSocket.close();
    }
}
