import java.net.*;
import java.io.*;

public class KnockKnockServer {
	
    public final static int DEFAULT_PORT = 4444;	
	
    public static void main(String[] args) throws IOException {

        ServerSocket serverSocket = null;
	
        int port = DEFAULT_PORT;
	

        if (args.length > 0) {
        try {port = Integer.parseInt(args[0]);}
        catch (NumberFormatException e) {}
        }
	
	
	
        try {
            // cria o socket. o SO tenta neste momento fazer um BIND deste socket
            // na porta solicitada. Se tiver problema, lanca excecao...
            serverSocket = new ServerSocket(port);
        } catch (IOException e) {
            System.err.println("Erro: nao aloquei socket na porta: "+ port);
            System.exit(1);
        }

        Socket clientSocket = null;
        try {
	    // fica esperando que o cliente entre em contato (solicite o servico na
            // na porta designada) Dizemos que o servico est escutando...
	    // PRIMITIVA BLOQUEANTE !!!!!!!!!!!!!!!!!!!!!!
            clientSocket = serverSocket.accept();
	    // passando por aqui, um novo socket cliente  criado. Ele contem 
            // o IP e a porta do CLIENTE e tb eh associado (BOUND) a porta local do
            // servico
            // AQUI TEMOS UM PRINCIPIO INTERESSANTISSIMO: o socket cliente
            // eh usado para comunicar com um cliente e o socker servidor fica
            // escutando outras solicitacoes.. este programa so aceita uma requisicao
        } catch (IOException e) {
            System.err.println("Accept failed.");
            System.exit(1);
        }

	// cria um write para escrever (mandar informacoes) para o cliente
        PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
	// cria um reader para ler (receber informacoes) o que chega do cliente
        BufferedReader in = new BufferedReader(
				new InputStreamReader(
				clientSocket.getInputStream()));
        String inputLine, outputLine;
        KnockKnockProtocol kkp = new KnockKnockProtocol();

        outputLine = kkp.processInput(null);
        out.println(outputLine);

        while ((inputLine = in.readLine()) != null) {
             outputLine = kkp.processInput(inputLine);
             out.println(outputLine);
             if (outputLine.equals("Bye."))
                break;
        }
        out.close();
        in.close();
        clientSocket.close();
        serverSocket.close();
    }
}

